"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stackdriver = void 0;
const logger_context_config_1 = require("../logger-context.config");
const prettyOptions = {
    translateTime: true,
    colorize: true,
};
const stackDriverErrorSeverityMapping = {
    trace: 'DEBUG',
    debug: 'DEBUG',
    warn: 'WARNING',
    info: 'INFO',
    error: 'ERROR',
    fatal: 'CRITICAL',
};
const loggerOptions = {
    timestamp: process.env.NODE_ENV !== 'production',
    level: process.env.NODE_ENV !== 'production' ? 'trace' : 'info',
    base: {},
    messageKey: 'message',
    formatters: {
        level: (lev, val) => {
            return { severity: stackDriverErrorSeverityMapping[lev] };
        },
    },
    prettyPrint: process.env.NODE_ENV !== 'production' ? prettyOptions : false,
};
exports.stackdriver = {
    logFieldNames: {
        context: 'context',
        labels: 'labels',
        trace: 'trace',
    },
    loggerOptions,
    context: logger_context_config_1.loggerContextConfig,
};
