"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.forceRequestToBeTracedMiddleware = void 0;
const common_1 = require("@nestjs/common");
const forceRequestToBeTracedMiddleware = (gcloudTracer, filterRequests = () => true) => (req, res, next) => {
    if (!gcloudTracer.isActive()) {
        throw new common_1.InternalServerErrorException(`You must call GcloudTracerService::start from your main application`);
    }
    if (filterRequests(req, res)) {
        gcloudTracer.forceRequestToBeTraced(req);
    }
    next();
};
exports.forceRequestToBeTracedMiddleware = forceRequestToBeTracedMiddleware;
