"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var GcloudTraceService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.GcloudTraceService = void 0;
const common_1 = require("@nestjs/common");
const trace_agent_1 = require("@google-cloud/trace-agent");
const constants_1 = require("../constants");
let GcloudTraceService = GcloudTraceService_1 = class GcloudTraceService {
    constructor() {
        this.logger = new common_1.Logger(GcloudTraceService_1.name);
    }
    static start(config = {}) {
        this.isActive = true;
        return trace_agent_1.start({
            ...{
                logLevel: process.env.NODE_ENV === 'production'
                    ? 1
                    : 2,
            },
            ...config,
        });
    }
    isActive() {
        return this.isActive;
    }
    get() {
        return trace_agent_1.get();
    }
    clean() { }
    async getTraceUrl() {
        const tracer = this.get();
        const context = tracer.getCurrentRootSpan().getTraceContext();
        if (!context) {
            return '';
        }
        let project;
        try {
            project = await tracer.getProjectId();
        }
        catch (e) {
            project = process.env.GCP_PROJECT_ID;
        }
        return `projects/${project}/traces/${context.traceId}`;
    }
    getTraceUrlFromEnv() {
        const context = this.get()
            .getCurrentRootSpan()
            .getTraceContext();
        const project = process.env.GCP_PROJECT_ID;
        if (!context || !project) {
            return '';
        }
        return `projects/${project}/traces/${context.traceId}`;
    }
    forceRequestToBeTraced(req) {
        const tracer = this.get();
        const context = tracer.getCurrentRootSpan().getTraceContext();
        if (!context) {
            this.logger.warn(`Unable to find a trace context for the given request!`);
            this.logger.warn(req);
            return req;
        }
        const traceId = context.traceId;
        const spanId = context.spanId;
        req.headers[constants_1.HEADER_GCLOUD_TRACE_CONTEXT] = `${traceId}/${spanId}/1`;
        return req;
    }
};
GcloudTraceService.isActive = false;
GcloudTraceService = GcloudTraceService_1 = __decorate([
    common_1.Injectable()
], GcloudTraceService);
exports.GcloudTraceService = GcloudTraceService;
