import { LoggerService } from '@nestjs/common';
import * as createPinoLogger from 'pino';
import { Context } from 'nestjs-context';
import { LoggerConfig } from '../config';
export declare class Logger implements LoggerService {
    private readonly config;
    private readonly appContext;
    private logger;
    private context;
    constructor(config?: LoggerConfig, appContext?: Context, logger?: createPinoLogger.Logger);
    setContext(context: string): void;
    hasContext(): boolean;
    private getMergingObject;
    verbose(message: any, context?: string, ...args: any[]): void;
    debug(message: any, context?: string, ...args: any[]): void;
    log(message: any, context?: string, ...args: any[]): void;
    warn(message: any, context?: string, ...args: any[]): void;
    error(message: any, trace?: string, context?: string, ...args: any[]): void;
}
