"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logger = void 0;
const uuid_1 = require("uuid");
const common_1 = require("@nestjs/common");
const createPinoLogger = require("pino");
const lodash_1 = require("lodash");
const nestjs_context_1 = require("nestjs-context");
const config_1 = require("../config");
let Logger = class Logger {
    constructor(config = new config_1.LoggerConfig(), appContext = new nestjs_context_1.Context(`Logger-${uuid_1.v4()}`, config.context, {}), logger = createPinoLogger(config.loggerOptions)) {
        this.config = config;
        this.appContext = appContext;
        this.logger = logger;
    }
    setContext(context) {
        this.context = context;
    }
    hasContext() {
        return !!this.context;
    }
    getMergingObject({ context, trace, }) {
        return lodash_1.pickBy({
            [this.config.getFieldNameContext()]: context ?? this.context,
            [this.config.getFieldNameTrace()]: trace,
            [this.config.getFieldNameLabels()]: this.appContext.createView(this.config.labels),
        }, (value) => !lodash_1.isEmpty(value));
    }
    verbose(message, context, ...args) {
        return this.logger.trace(this.getMergingObject({ context }), message, ...args);
    }
    debug(message, context, ...args) {
        const merge = this.getMergingObject({ context });
        return this.logger.debug(merge, message, ...args);
    }
    log(message, context, ...args) {
        return this.logger.info(this.getMergingObject({ context }), message, ...args);
    }
    warn(message, context, ...args) {
        return this.logger.warn(this.getMergingObject({ context }), message, ...args);
    }
    error(message, trace, context, ...args) {
        if (message instanceof Error) {
            message = message.message;
            trace = trace || message.stack;
        }
        return this.logger.error(this.getMergingObject({ trace, context }), message, ...args);
    }
};
Logger = __decorate([
    common_1.Injectable({ scope: common_1.Scope.TRANSIENT }),
    __param(0, common_1.Optional()),
    __param(1, common_1.Optional()),
    __param(2, common_1.Optional()),
    __metadata("design:paramtypes", [config_1.LoggerConfig,
        nestjs_context_1.Context, Object])
], Logger);
exports.Logger = Logger;
